<!-- 现场检测记录列表 -->
<script lang="ts" setup name="FieldTestRecordList">
import type { Ref } from 'vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { IList, IListQuery } from './record-interface'
import { printJSON } from '@/utils/printUtils'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { getDictByCode } from '@/api/system/dict'
import type { dictType } from '@/views/device/receive/receive'
import type { IMenu } from '@/components/buttonBox/buttonBox'
import ApprovalDialog from '@/components/Approval/ApprovalDialog.vue'
import ButtonBox from '@/components/buttonBox/buttonBox.vue'
import { exportFile } from '@/utils/exportUtils'
import { delFieldTestRecordList, exportRecordDetail, getFieldTestRecordList } from '@/api/business/fieldTest/record'
import { SCHEDULE } from '@/utils/scheduleDict'
import { cancelApproval } from '@/api/approval'
import { keepSearchParams, renewSearchParams } from '@/utils/keepQuery'
const approvalDialog = ref() // 审批对话ref
const $route = useRoute()
const $router = useRouter()
const { proxy } = getCurrentInstance() as any
const TabActiveButton = 'FieldTestRecordList'
const loadingTable = ref(false)
const menu = ref<IMenu[]>([]) // 审批状态按钮组合
const active = ref('') // 右上方按钮
// 查询条件
const listQuery: Ref<IListQuery> = ref({
  laboratoryName: '', // 实验室
  logNo: '', // 记录编号
  recorderName: '', // 记录人
  customerName: '', // 委托方名称
  limit: 20,
  offset: 1,
})
// 页面跳转之前保存参数
onBeforeRouteLeave((to: any) => {
  keepSearchParams(to.path, 'fieldTest-record', listQuery.value)
})
// 重新赋值
listQuery.value = renewSearchParams('fieldTest-record') || {
  laboratoryName: '', // 实验室
  logNo: '', // 记录编号
  recorderName: '', // 记录人
  customerName: '', // 委托方名称
  limit: 20,
  offset: 1,
}
// 表头
const columns = ref<TableColumn[]>([
  { text: '记录编号', value: 'logNo', align: 'center', width: '160px' },
  // { text: '实验室', value: 'laboratoryId', align: 'center' },
  { text: '创建人', value: 'recorderName', align: 'center' },
  { text: '现场工作地点', value: 'executiveAddress', align: 'center' },
  { text: '创建时间', value: 'recordTime', align: 'center', width: '180' },
  { text: '委托方名称', value: 'customerName', align: 'center' },
])
const list = ref<IList[]>([]) // 列表
const total = ref(0) // 数据总条数
// 选中的内容
const checkoutList = ref<string[]>([])

// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  // if (!isNowPage) {
  //   // 是否显示当前页，否则跳转第一页
  //   listQuery.value.offset = 1
  // }
  // 模拟数据
  getFieldTestRecordList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}
// 清除条件
const clearList = () => {
  listQuery.value = {
    laboratoryName: '', // 实验室
    logNo: '', // 记录编号
    recorderName: '', // 记录人
    customerName: '', // 委托方名称
    limit: 20,
    offset: 1,
  }
  fetchData()
}
// 搜索
const searchList = () => {
  fetchData(true)
}

// 新建
const add = () => {
  $router.push({
    path: '/fieldTest/record/add',
  })
}

// 打印
const printList = () => {
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (checkoutList.value.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '现场检测记录列表')
  }
  else if (checkoutList.value.length > 0) {
    const printList = list.value.filter((item: IList) => checkoutList.value.includes(item.id))
    printJSON(printList, properties, '现场检测记录列表')
  }
  else {
    ElMessage.warning('无可打印内容')
  }
}

// 导出
const exportAll = () => {
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (list.value.length > 0) {
    const params = {
      laboratoryName: listQuery.value.laboratoryName, // 实验室
      logNo: listQuery.value.logNo, // 记录编号
      recorderName: listQuery.value.recorderName, // 记录人
      customerName: listQuery.value.customerName, // 委托方名称
      limit: 20,
      offset: 1,
      ids: checkoutList.value,
    }
    // 导出接口
    exportRecordDetail(params).then((res) => {
      const blob = new Blob([res.data])
      exportFile(blob, '现场检测记录列表.xlsx')
    })
  }
  else {
    ElMessage.warning('无数据可导出数据')
  }
  // 关闭loading
  loading.close()
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// 操作
const handleEdit = (row: IList, val: string, title = '') => {
  // if (val === '删除') {
  //   ElMessageBox.confirm(
  //     '确认删除吗？',
  //     '提示',
  //     {
  //       confirmButtonText: '确认',
  //       cancelButtonText: '取消',
  //       type: 'warning',
  //     },
  //   )
  //     .then(() => {
  //       delFieldTestRecordList({ id: row.id }).then((res) => {
  //         ElMessage({
  //           type: 'success',
  //           message: '删除成功',
  //         })
  //         fetchData(true)
  //       })
  //     })
  // }
  if (val === 'detail' || val === 'edit') { // 详情和编辑
    $router.push({
      path: `/fieldTest/record/${val}/${row.id}`,
    })
  }
}
onMounted(async () => {
  fetchData(false)
})
</script>

<template>
  <div>
    <!-- 布局 -->
    <app-container>
      <search-area :need-clear="true" @search="searchList" @clear="clearList">
        <search-item>
          <el-input v-model.trim="listQuery.logNo" placeholder="记录编号" class="short-input" clearable />
        </search-item>
        <!-- <search-item>
          <el-input v-model.trim="listQuery.laboratoryName" placeholder="实验室" class="short-input" clearable />
        </search-item> -->
        <search-item>
          <el-input v-model.trim="listQuery.recorderName" placeholder="创建人" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.customerName" placeholder="委托方名称" class="short-input" clearable />
        </search-item>
      </search-area>
      <table-container>
        <template #btns-right>
          <icon-button icon="icon-add" title="新建" type="primary" @click="add" />
          <icon-button icon="icon-export" title="导出" type="primary" @click="exportAll" />
          <icon-button icon="icon-print" title="打印" type="primary" @click="printList" />
        </template>
        <normal-table
          :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="loadingTable"
          is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
        >
          <template #preColumns>
            <el-table-column label="序号" width="55" align="center">
              <template #default="scope">
                {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
              </template>
            </el-table-column>
          </template>
          <template #columns>
            <el-table-column
              label="操作"
              align="center"
              fixed="right"
              width="120"
            >
              <template #default="{ row }">
                <el-button
                  size="small"
                  link
                  type="primary"
                  @click="handleEdit(row, 'edit')"
                >
                  编辑
                </el-button>
                <el-button
                  size="small"
                  type="primary"
                  link
                  @click="handleEdit(row, 'detail')"
                >
                  详情
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
    </app-container>
  </div>
</template>
